*********************************************************************** IKQ00010
*     -  THIS SHORT ASSEMBLER MODULE IS JUST AN EXAMPLE FOR           * IKQ00020
*        THE INPUT/OUTPUT HANDLING OF THE DIFFERENT VDA EXITS.        * IKQ00030
*        NOTHING IS REALLY DONE HERE EXCEPT TESTING FOR THE EXIT TYPE,* IKQ00040
*        SETTING THE REQUIRED RETURN CODE AND RETURNING TO VSAM.      * IKQ00050
*                                                                     * IKQ00060
*     -  THE INPUT TO THIS ROUTINE FROM VSAM IS:                      * IKQ00070
*        -  REG 1 POINTS TO THE PARM LIST, HERE CALLED EXWAPARM.      * IKQ00080
*        -  REG 13 ADDRESSES A 72 BYTES SAVER AREA                    * IKQ00090
*        -  REG 14 IS THE RETURN ADDRESS OF VSAM                      * IKQ00100
*                                                                     * IKQ00110
*     -  THIS MODULE IS IN RMODE 31 AND AMODE 31 (ABOVE 16 MEG)       * IKQ00120
*     -  THIS MODULE IS REENTRANT.                                    * IKQ00130
*********************************************************************** IKQ00140
IKQVEX01 CSECT ,                                                        IKQ00150
IKQVEX01 RMODE ANY                                                      IKQ00160
IKQVEX01 AMODE 31                                                       IKQ00170
         TITLE 'VDA EXIT DUMMY MODULE FOR TEST PURPOSES'                IKQ00180
         USING *,15           REG 15 IS THE TEMPORARY BASE              IKQ00190
VEX001   B     VEX002         SKIP EYE CATCHER                          IKQ00200
         DC    CL8'IKQVEX01'                                            IKQ00210
         DC    C' VDA EXIT DUMMY MODULE FOR TEST PURPOSES'              IKQ00220
         DS    0F                                                       IKQ00230
*********************************************************************   IKQ00240
*        ESTABLISH BASE AND SAVE REGISTERS                          *   IKQ00250
*********************************************************************   IKQ00260
VEX002   EQU   *                                                        IKQ00270
         STM   14,12,12(13)   STORE USER'S REGISTERS                    IKQ00280
         DROP  15             REG15 IS NOT LONGER THE BASE              IKQ00290
         BALR  12,0           LOAD REG12 FOR BASE                       IKQ00300
         USING *,12           REG12 IS THE BASE REGISTER NOW            IKQ00310
*********************************************************************   IKQ00320
*        TEST FOR THE EXIT TYPES NOW                                *   IKQ00330
*********************************************************************   IKQ00340
         USING EXWAPARM,1     BASE OF PARAMETER LIST                    IKQ00350
*                                                                       IKQ00360
         TM    EXTYPE,EXOPN   TEST IF OPEN EXIT                         IKQ00370
         BO    VEXOPN         YES, HANDLE OPEN EXIT                     IKQ00380
*                                                                       IKQ00390
         TM    EXTYPE,EXCLO   TEST IF CLOSE EXIT                        IKQ00400
         BO    VEXCLO         YES, HANDLE CLOSE EXIT                    IKQ00410
*                                                                       IKQ00420
         TM    EXTYPE,EXRMIN  TEST IF DATA ACCESS BEGIN                 IKQ00430
         BO    VEXRMIN        YES, HANDLE DATA ACCESS BEGIN             IKQ00440
*                                                                       IKQ00450
         TM    EXTYPE,EXRMOUT TEST IF DATA EXIT END                     IKQ00460
         BO    VEXRMOUT       YES, HANDLE DATA EXIT END                 IKQ00470
*                                                                       IKQ00480
         TM    EXTYPE,EXRMERR TEST IF DATA EXIT ERROR                   IKQ00490
         BO    VEXRMERR       YES, HANDLE DATA EXIT ERROR               IKQ00500
*
         B     RETURN         RETURN TO VSAM
*                                                                       IKQ00510
*********************************************************************   IKQ00520
*        THE NEXT ENTRIES DO NOTHING. THEY SIMPLY RETURN TO VSAM.   *   IKQ00530
*        THIS IS AN EXAMPLE OF A SKELETON ONLY.                     *   IKQ00540
*********************************************************************   IKQ00550
*                                                                       IKQ00560
VEXOPN   EQU   *              ENTRY POINT FOR SUCCESSFUL OPEN           IKQ00570
         SLR   15,15          REG15=0 VDA EXIT REQUESTED/SUCCESSFUL     IKQ00580
         B     RETURN         RETURN TO VSAM                            IKQ00590
*                                                                       IKQ00600
VEXCLO   EQU   *              ENTRY POINT FOR SUCCESSFUL CLOSE          IKQ00610
         B     RETURN         RETURN TO VSAM - NO RETURN CODE           IKQ00620
*                                                                       IKQ00630
VEXRMIN  EQU   *              ENTRY POINT FOR DATA ACCESS BEGIN         IKQ00640
         SLR   15,15          REG15=0 VDA EXIT REQUESTED/SUCCESSFUL     IKQ00650
         B     RETURN         RETURN TO VSAM                            IKQ00660
*                                                                       IKQ00670
VEXRMOUT EQU   *              ENTRY POINT FOR DATA ACCESS END           IKQ00680
         B     RETURN         RETURN TO VSAM - NO REURN CODE            IKQ00690
*                                                                       IKQ00700
VEXRMERR EQU   *              ENTRY POINT FOR DATA ACCESS ERROR         IKQ00710
         B     RETURN         RETURN TO VSAM - NO RETURN CODE           IKQ00720
*                                                                       IKQ00730
*********************************************************************   IKQ00740
*        COMMON ENTRY POINT - RETURN TO VSAM                        *   IKQ00750
*********************************************************************   IKQ00760
RETURN   EQU   *              NORMAL RETURN                             IKQ00770
         L     14,12(13)      RELOAD RETURN REGISTER                    IKQ00780
         LM    0,12,20(13)    RELOAD USER'S REGISTERS                   IKQ00790
         BR    14             RETURN TO VSAM                            IKQ00800
*********************************************************************   IKQ00810
*        DSECT EXWAPARM - THE MAPPING OF THE PARAMETER LIST         *   IKQ00820
*********************************************************************   IKQ00830
         DSECT                                                          IKQ00840
         EXWAPARM             DSECT OF PARAMETER LIST                   IKQ00850
         END                                                            IKQ00860
